<?php
/*********************************************
* mass import.php
*
* permet d'importer en masse des artices dans spip 
* sans passer par l'interface admin et tous ses clics
* 
* version: 	1.1
* date: 	  2005.12.12
* auteur: 	erational.org
* licence:	GPL
*
*
* 1.1 (2005.12.12): ajout sparateur fin, regex plus fine
* 1.0 (2005.12.07): first release
*
**********************************************/


//-----------------------------------------
//  Parametres  ( diter au besoin)
//-----------------------------------------
// La rubrique par defaut dans lequel on importe les donnes si celle ci n'est pas spcifie par l'utilisateur
define ("ID_RUBRIQUE_PAR_DEFAUT","1");

// ID de l'auteur responsable des imports sinon on prendra celui de l'utilisateur identifi
define ("ID_AUTEUR_PAR_DEFAUT","1");
define ("UTILISER_AUTEUR_PAR_DEFAUT","0"); // 0 ou 1 


//-----------------------------------------
//  functions
//-----------------------------------------
function convertspip_uri($str) { 	// convertit les chaines http:// en syntaxe spip [ ]	 
	 return eregi_replace('[^(->)\'\"]http://([^[:space:]<]*)', ' [http://\\1->http://\\1]', $str); 
}


//-----------------------------------------
//  main
//-----------------------------------------
include ("inc.php");
include_ecrire ("inc_admin.php");

if (UTILISER_AUTEUR_PAR_DEFAUT) $auteur_import_id = ID_AUTEUR_PAR_DEFAUT;
						else $auteur_import_id = $auteur_session['id_auteur'];


//  graphisme lay-out
debut_page(_T('massimport:mi01_titre'), "administration");
echo "<br /><br />";
gros_titre(_T('massimport:mi01_titre'));

debut_gauche();
debut_boite_info();
echo _T('massimport:mi02_readme');
fin_boite_info();

debut_droite();

if ($connect_statut == "0minirezo") {
	// data recus ?
	if (!isset($_POST['mass_import'])) {
		// pas de donnes, on affiche le formulaire d'import
		echo "<form method='post'><input type='hidden' name='mass_import' value='1' />\n";
		echo "<br /><input type='text' size='8' name='rub' value='".ID_RUBRIQUE_PAR_DEFAUT."' /> "._T('massimport:mi03_rub_num');
		echo "<br /><input type='text' size='8' name='sep_title' value='$$$' /> "._T('massimport:mi05_sep_art');
		echo "<br /><input type='text' size='8' name='sep_art' value='***' /> "._T('massimport:mi04_sep_interart');		
		echo "<br />"._T('massimport:mi06_statut');
		echo "<br /><input type='radio' name='statut' value='prop' checked='checked' /> "._T('texte_statut_propose_evaluation');
		echo "<br /><input type='radio' name='statut' value='publie' /> "._T('texte_statut_publie');
		echo "<br /><br /><input type='checkbox' name='conv_url' value='1' /> "._T('massimport:mi07_convert_url');    	
		echo "<br /><br />"._T('massimport:mi08_text_import')."<br />\n";
		echo "<textarea name='txt' rows='30' cols='52'></textarea><br />\n";
		echo "<input type='submit' value='"._T('massimport:mi09_import')."' />\n";
		echo "</form>\n";
		
	} else {
		// traitement des donnes du formulaire
		$txt = $_POST['txt'];
		$sep_art  = $_POST['sep_art'];
		$sep_title = $_POST['sep_title'];
		$conv_url = $_POST['conv_url'];		
		$statut = $_POST['statut'];
		$rub = (int) $_POST['rub'];
		
		// rubrique 'import' valide ?
		$resq =spip_query("SELECT * FROM spip_rubriques WHERE id_rubrique=$rub");
		$res = spip_fetch_array($resq);
		if (!$res) die (_T('massimport:mi10_error_norub'));
		$lang = $res['lang'];
		$rub_titre = stripslashes($res['titre']);
		echo "<h3>Rubrique destination: <a href='naviguer.php?id_rubrique=$rub'>$rub_titre</a> ($lang)</h3>\n";
		
		// lecture configuration forums
		$forums_publics = substr(lire_meta('forums_publics'),0,3);
		
		// on  traite le resultat
		$txt .= $sep_art; // ajout d'un separateur pour ne pas perdre le dernier item
		$articles = explode($sep_art, $txt);
		foreach($articles as $k=>$val) {
			$current_article = trim($val);
			if ($conv_url == 1) $current_article = convertspip_uri($current_article);
			if ($conv_url == 2) $current_article = nl2br($current_article);
			$current_article_content = explode($sep_title,$current_article);
			if (count($current_article_content)==2){		// pas d'erreur, on recupere exactement deux elements
				$temp_titre = addslashes(trim($current_article_content[0]));
				if ($temp_titre=="") $temp_titre="????";
				$temp_text = addslashes(trim($current_article_content[1]));
				spip_query("INSERT INTO spip_articles (id_rubrique, titre, texte, statut, date, accepter_forum, lang) VALUES ($rub, '$temp_titre', '$temp_text' , '$statut', NOW(), '$forums_publics', '$lang')");
				$id_article = spip_insert_id();
				spip_query("INSERT INTO spip_auteurs_articles (id_auteur, id_article) VALUES ($auteur_import_id, $id_article)");	
				echo "<br />"._T('massimport:mi12_article_sucess')." $id_article: <a href='articles.php?id_article=$id_article'>".stripslashes($temp_titre)."</a>\n";
			}
			
		}	

		// lien pour importer de nouveau
		echo "<p><a href='massimport.php'>"._T('massimport:mi13_new_import')."</a></p>\n";
	}
}
fin_page();

?>
